import 'package:chessboard_js/providers/providers.dart';
import 'package:flutter_hooks/flutter_hooks.dart';

import '../chessboard_notation/notation_widgets.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:hooks_riverpod/hooks_riverpod.dart';
import '../chessboard/controller.dart';

/// Panel to display chessboard_notation
class ChessboardNotation extends HookWidget {
  ChessboardNotation({
    required this.height,
    required this.width,
    required this.notationTextColor,
    this.backgroundColor = Colors.black,
    required this.controller,
//    required this.onTapMove,
  });

  final double height;
  final double width;
  final Color backgroundColor;
  final Color notationTextColor;
  final ChessboardController controller;
//  final Function(int) onTapMove;

  @override
  Widget build(BuildContext context) {
    final result = useProvider(
        moveHistoryProvider((controller)).select((history) => history.result));

    return CustomContainer(
      width: width,
      height: height,
      child: Padding(
        padding: const EdgeInsets.all(8.0),
        child: Column(
          mainAxisSize: MainAxisSize.max,
          mainAxisAlignment: MainAxisAlignment.spaceAround,
          children: [
            TopPlayerName(
              whiteTowardUser: controller.whiteTowardUser,
              white: controller.white,
              black: controller.black,
            ),
//            if (moves.isNotEmpty)
            Expanded(
              child: Padding(
                  padding: const EdgeInsets.symmetric(vertical: 5.0),
                  child: NotationMoves(
                    controller: controller,
                    notationTextColor: notationTextColor,
//                    onTapMove: onTapMove,
                  )),
            ),
            if (result != null) Spacer(),
            if (result != null)
              NotationResult(
                result: result,
                notationTextColor: notationTextColor,
              ),
            if (result != null) Spacer(),
            BottomPlayerName(
              whiteTowardUser: controller.whiteTowardUser,
              white: controller.white,
              black: controller.black,
            ),
          ],
        ),
      ),
    );
  }
}
